package com.fjhx.flow.core;

import com.alibaba.fastjson.JSONObject;
import com.fjhx.flow.enums.HandleTypeEnum;
import org.springframework.core.NamedThreadLocal;

import java.util.Map;

public class FlowThreadLocalUtil {

    private static final ThreadLocal<FlowThreadLocalData> FLOW_HOLDER = new NamedThreadLocal<>("saas-flow");

    public static Long getFlowId() {
        return getData().getFlowId();
    }

    public static void setFlowId(Long flowId) {
        getData().setFlowId(flowId);
    }

    public static Long getBusinessId() {
        return getData().getBusinessId();
    }

    public static void setBusinessId(Long businessId) {
        getData().setBusinessId(businessId);
    }

    public static JSONObject getCurrentData() {
        return getData().getCurrentData();
    }

    public static void setCurrentData(JSONObject currentData) {
        getData().setCurrentData(currentData);
    }

    public static JSONObject getStartData() {
        return getData().getStartData();
    }

    public static void setStartData(JSONObject startData) {
        getData().setStartData(startData);
    }

    public static Map<String, Object> getTemplateData() {
        return getData().getTemplateData();
    }

    public static void setTemplateData(Map<String, Object> templateData) {
        getData().setTemplateData(templateData);
    }

    public static HandleTypeEnum getHandleTypeEnum() {
        return getData().getHandleTypeEnum();
    }

    public static void setHandleTypeEnum(HandleTypeEnum handleTypeEnum) {
        getData().setHandleTypeEnum(handleTypeEnum);
    }

    private static FlowThreadLocalData getData() {
        FlowThreadLocalData flowThreadLocalData = FLOW_HOLDER.get();
        if (flowThreadLocalData == null) {
            flowThreadLocalData = new FlowThreadLocalData();
            FLOW_HOLDER.set(flowThreadLocalData);
        }
        return flowThreadLocalData;
    }

}
